include:
  - local: 'codequality.yml'

codequality:markdownlint:
  stage: lint
  needs: []
  extends: .codequality:markdownlint
  variables:
    MARKDOWNLINT_OPTIONS: "${CI_PROJECT_DIR}/tests/markdownlint"
  script:
    - !reference [".codequality:markdownlint", "script"]
    # render the file, which validates the length, and the syntax
    - python3 -m json.tool markdownlint-${CI_JOB_NAME_SLUG}.json
  artifacts:
    # export path for codequality:combine
    paths:
      - markdownlint*.json

codequality:markdownlint:nolint:
  extends: codequality:markdownlint
  script:
    # write a .markdownlintignore file that ignores bad.md
    - echo "tests/markdownlint/bad.md" > .markdownlintignore
    # run the check (which should return no issues)
    - !reference [".codequality:markdownlint", "script"]
    # check that the json file is empty
    - test $(cat markdownlint-${CI_JOB_NAME_SLUG}.json | wc -l) -eq 0
  artifacts:
    # export path for codequality:combine
    paths:
      - markdownlint*.json

codequality:shellcheck:
  stage: lint
  needs: []
  extends: .codequality:shellcheck
  variables:
    SHELLCHECK_TARGETS: "tests/shellcheck/*.sh"

codequality:combine:
  stage: .post
  extends:
    - .codequality:combine
  needs:
    - codequality:markdownlint
    - codequality:markdownlint:nolint
    - codequality:shellcheck
    - python:flake8
    - python:radon
